aboutsummaryrefslogtreecommitdiffstatshomepage
path: root/.bash_utils
diff options
context:
space:
mode:
authorEgor Tensin <Egor.Tensin@gmail.com>2016-08-17 22:58:15 +0200
committerEgor Tensin <Egor.Tensin@gmail.com>2016-08-17 22:58:15 +0200
commit35d858363a88f1d985ba36cf0e18de6ab0ccfcd1 (patch)
tree611e856f77effc512aaa317137039bcb9f49060e /.bash_utils
parentmove Windows-specific stuff to .appdata/ (diff)
downloadlinux-home-35d858363a88f1d985ba36cf0e18de6ab0ccfcd1.tar.gz
linux-home-35d858363a88f1d985ba36cf0e18de6ab0ccfcd1.zip
move .bashrc_* to .bash_utils/
Diffstat (limited to '.bash_utils')
-rw-r--r--.bash_utils/cxx.sh118
-rw-r--r--.bash_utils/distr.sh29
-rw-r--r--.bash_utils/git.sh102
-rw-r--r--.bash_utils/netwrix.sh38
-rw-r--r--.bash_utils/text.sh27
5 files changed, 314 insertions, 0 deletions
diff --git a/.bash_utils/cxx.sh b/.bash_utils/cxx.sh
new file mode 100644
index 0000000..49d4549
--- /dev/null
+++ b/.bash_utils/cxx.sh
@@ -0,0 +1,118 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2016 Egor Tensin <Egor.Tensin@gmail.com>
+# This file is part of the "Cygwin configuration files" project.
+# For details, see https://github.com/egor-tensin/cygwin-home.
+# Distributed under the MIT License.
+
+runc_flags=('-Wall' '-Wextra')
+
+runc() (
+ set -o errexit -o nounset -o pipefail
+
+ local -a c_flags=("${runc_flags[@]+"${runc_flags[@]}"}")
+ local -a src_files
+ local -a prog_flags
+
+ while [ "$#" -gt 0 ]; do
+ case "$1" in
+ -c|--c-flags)
+ if [ "$#" -le 1 ]; then
+ echo "${FUNCNAME[0]}: missing argument for parameter: $1" >&2
+ return 1
+ fi
+ shift
+ c_flags+=("$1")
+ shift
+ ;;
+
+ -h|--help)
+ echo "usage: ${FUNCNAME[0]} [-h|--help] [-c|--c-flags FLAG]"
+ return 0
+ ;;
+
+ --)
+ shift
+ break
+ ;;
+
+ *)
+ src_files+=("$( realpath "$1" )")
+ shift
+ ;;
+ esac
+ done
+
+ prog_flags=("$@")
+
+ local build_dir
+ build_dir="$( mktemp --directory )"
+
+ trap "$( printf 'popd > /dev/null && rm -rf %q' "$build_dir" )" 0
+ pushd "$build_dir" > /dev/null
+
+ local output_name
+ output_name="$( mktemp --tmpdir=. "${FUNCNAME[0]}XXX.exe" )"
+
+ gcc -o "$output_name" \
+ "${c_flags[@]+"${c_flags[@]}"}" \
+ "${src_files[@]+"${src_files[@]}"}"
+
+ "$output_name" "${prog_flags[@]+"${prog_flags[@]}"}"
+)
+
+runcxx_flags=('-Wall' '-Wextra' '-std=c++14')
+
+runcxx() (
+ set -o errexit -o nounset -o pipefail
+
+ local -a cxx_flags=("${runcxx_flags[@]+"${runcxx_flags[@]}"}")
+ local -a src_files
+ local -a prog_flags
+
+ while [ "$#" -gt 0 ]; do
+ case "$1" in
+ -c|--cxx-flags)
+ if [ "$#" -le 1 ]; then
+ echo "${FUNCNAME[0]}: missing argument for parameter: $1" >&2
+ return 1
+ fi
+ shift
+ cxx_flags+=("$1")
+ shift
+ ;;
+
+ -h|--help)
+ echo "usage: ${FUNCNAME[0]} [-h|--help] [-c|--cxx-flags FLAG]"
+ return 0
+ ;;
+
+ --)
+ shift
+ break
+ ;;
+
+ *)
+ src_files+=("$( realpath "$1" )")
+ shift
+ ;;
+ esac
+ done
+
+ prog_flags=("$@")
+
+ local build_dir
+ build_dir="$( mktemp --directory )"
+
+ trap "$( printf 'popd > /dev/null && rm -rf %q' "$build_dir" )" 0
+ pushd "$build_dir" > /dev/null
+
+ local output_name
+ output_name="$( mktemp --tmpdir=. "${FUNCNAME[0]}XXX.exe" )"
+
+ g++ -o "$output_name" \
+ "${cxx_flags[@]+"${cxx_flags[@]}"}" \
+ "${src_files[@]+"${src_files[@]}"}"
+
+ "$output_name" "${prog_flags[@]+"${prog_flags[@]}"}"
+)
diff --git a/.bash_utils/distr.sh b/.bash_utils/distr.sh
new file mode 100644
index 0000000..8e7b84c
--- /dev/null
+++ b/.bash_utils/distr.sh
@@ -0,0 +1,29 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2016 Egor Tensin <Egor.Tensin@gmail.com>
+# This file is part of the "Cygwin configuration files" project.
+# For details, see https://github.com/egor-tensin/cygwin-home.
+# Distributed under the MIT License.
+
+readonly checksums_path='sha1sums.txt'
+
+update_checksums() {
+ sha1sum -- "$@" > "$checksums_path"
+}
+
+update_checksums_distr() (
+ set -o errexit -o nounset -o pipefail
+
+ local -a paths
+ local path
+
+ while IFS= read -d '' -r path; do
+ paths+=("$path")
+ done < <( find . -type f -\( -iname '*.exe' -o -iname '*.iso' -\) -print0 )
+
+ update_checksums "${paths[@]+"${paths[@]}"}"
+)
+
+verify_checksums() {
+ sha1sum --check "$checksums_path"
+}
diff --git a/.bash_utils/git.sh b/.bash_utils/git.sh
new file mode 100644
index 0000000..54e50f6
--- /dev/null
+++ b/.bash_utils/git.sh
@@ -0,0 +1,102 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2016 Egor Tensin <Egor.Tensin@gmail.com>
+# This file is part of the "Cygwin configuration files" project.
+# For details, see https://github.com/egor-tensin/cygwin-home.
+# Distributed under the MIT License.
+
+list_repo_files() (
+ set -o errexit -o nounset -o pipefail
+
+ local -a cmd=(git ls-files)
+
+ while [ "$#" -gt 0 ]; do
+ case "$1" in
+ -z|-0)
+ cmd+=(-z)
+ shift
+ ;;
+
+ -h|--help)
+ echo "usage: ${FUNCNAME[0]} [-h|--help] [-z|-0]"
+ return 0
+ ;;
+
+ *)
+ echo "${FUNCNAME[0]}: unrecognized parameter: $1" >&2
+ return 1
+ ;;
+ esac
+ done
+
+ eval "${cmd[@]+"${cmd[@]}"}"
+)
+
+list_repo_dirs() (
+ set -o errexit -o nounset -o pipefail
+
+ local -a cmd=(git ls-tree -d -r)
+
+ while [ "$#" -gt 0 ]; do
+ case "$1" in
+ -z|-0)
+ cmd+=(-z)
+ shift
+ ;;
+
+ -h|--help)
+ echo "usage: ${FUNCNAME[0]} [-h|--help] [-z|-0]"
+ return 0
+ ;;
+
+ *)
+ echo "${FUNCNAME[0]}: unrecognized parameter: $1" >&2
+ return 1
+ ;;
+ esac
+ done
+
+ cmd+=(--name-only HEAD)
+
+ eval "${cmd[@]+"${cmd[@]}"}"
+)
+
+tighten_repo_security() (
+ set -o errexit -o nounset -o pipefail
+
+ list_repo_files -z | xargs -0 chmod 0600
+ list_repo_dirs -z | xargs -0 chmod 0700
+ chmod 0700 .git
+)
+
+backup_repo() (
+ set -o errexit -o nounset -o pipefail
+
+ local repo_dir
+ repo_dir="$( realpath . )"
+ local repo_name
+ repo_name="$( basename "$repo_dir" )"
+ local backup_dir="$repo_dir"
+
+ if [ $# -eq 1 ]; then
+ backup_dir="$1"
+ elif [ $# -gt 1 ]; then
+ echo "usage: ${FUNCNAME[0]} [BACKUP_DIR]" >&2
+ exit 1
+ fi
+
+ local zip_name
+ zip_name="${repo_name}_$( date -u +'%Y%m%dT%H%M%S' ).zip"
+
+ git archive \
+ --format=zip -9 \
+ --output="$backup_dir/$zip_name" \
+ --remote="$repo_dir" \
+ HEAD
+)
+
+backup_repo_dropbox() (
+ set -o errexit -o nounset -o pipefail
+
+ backup_repo "$USERPROFILE/Dropbox/backups"
+)
diff --git a/.bash_utils/netwrix.sh b/.bash_utils/netwrix.sh
new file mode 100644
index 0000000..0f79937
--- /dev/null
+++ b/.bash_utils/netwrix.sh
@@ -0,0 +1,38 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2016 Egor Tensin <Egor.Tensin@gmail.com>
+# This file is part of the "Cygwin configuration files" project.
+# For details, see https://github.com/egor-tensin/cygwin-home.
+# Distributed under the MIT License.
+
+source .bash_utils/git.sh || return
+source .bash_utils/text.sh || return
+
+export nwx_host=172.28.10.2
+export nwx_dev2=172.28.19.60
+export nwx_dev3=172.28.19.61
+
+lint_webapi() (
+ set -o errexit -o nounset -o pipefail
+
+ local root_dir='/cygdrive/c/Netwrix Auditor/CurrentVersion-AuditCore-Dev/AuditCore/Sources'
+
+ local -a paths
+ local path
+
+ cd "$root_dir/Configuration"
+ while IFS= read -d '' -r path; do
+ paths+=("$path")
+ done < <( find . -type f -\( -iname 'WebAPI*.acinc' -o -iname 'WebAPI*.acconf' -\) -print0 )
+
+ cd "$root_dir/Subsystems/PublicAPI"
+ while IFS= read -d '' -r path; do
+ paths+=("$path")
+ done < <( find . -type f -\( -iname '*.cpp' -o -iname '*.h' -\) -print0 )
+
+ doslint "${paths[@]+"${paths[@]}"}"
+)
+
+backup_repo_nwx() {
+ backup_repo '//spbfs02/P/Personal/Egor Tensin'
+}
diff --git a/.bash_utils/text.sh b/.bash_utils/text.sh
new file mode 100644
index 0000000..5a678ee
--- /dev/null
+++ b/.bash_utils/text.sh
@@ -0,0 +1,27 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2016 Egor Tensin <Egor.Tensin@gmail.com>
+# This file is part of the "Cygwin configuration files" project.
+# For details, see https://github.com/egor-tensin/cygwin-home.
+# Distributed under the MIT License.
+
+alias dos2eol='sed --binary --in-place '"'"'s/\(\r\?\)$//'"'"
+alias eol2dos='sed --binary --in-place '"'"'s/\r\?$/\r/'"'"
+
+alias trim='sed --binary --in-place '"'"'s/[[:blank:]]*\(\r\?\)$/\1/'"'"
+
+alias trimeol='sed --binary --in-place -e :a -e '"'"'/^\n*$/{$d;N;ba}'"'"
+alias trimdoseol='sed --binary --in-place -e :a -e '"'"'/^\(\r\n\)*\r$/{$d;N;ba}'"'"
+
+alias eol='sed --binary --in-place '"'"'$a\'"'"
+alias doseol='sed --binary --in-place '"'"'$s/\r\?$/\r/;a\'"'"
+
+alias trimbom='sed --binary --in-place '"'"'1 s/^\xef\xbb\xbf//'"'"
+
+lint() {
+ trim "$@" && trimeol "$@" && eol "$@"
+}
+
+doslint() {
+ trim "$@" && trimdoseol "$@" && doseol "$@"
+}